<?php
function getcountries() {
  global $countries,$ncountries;
  $ncountries=0;
  /* open qsl.countries and get the list of coutries */
  $fd=fopen("qsl.countries","r");
  if (!$fd) {
    echo "<p class=\"error\">Error opening qsl.countries file</p>";
    return -1;
  }
  $i=0;
  while (!feof($fd)) {
    $line=fgets($fd,256);
    if ($line[0]!='#' && sscanf($line,"%s %s %d\n",&$country,&$prefix,&$nqsl)==3) {
      $countries[$i++]=array($country,$prefix,$nqsl);
    }
    $ncountries=$i;
  }
  fclose($fd);
}

function listcountries($qsl) {
  global $countries,$ncountries;
  for ($i=0;$i<$ncountries;$i++) {
    if ($qsl) /* $qsl==1 if i must list only countries within QSLes. */
      if ($countries[$i][2]==0)
        continue;
    printf("<option>%s",$countries[$i][0]);
  }
}

function listqslfmcountry($country) {
  /* List all QSL from the specified country */
  $fd=opendir($country);
  while (($file = readdir($fd))!=false) {
    if (($len=strpos($file,".info"))>0) {
      $qslcall=substr($file,0,$len);
      $qsl=file("$country/$file");
      $count=count($qsl);
      if ($count%6==0) { /* file.info: 1=>qslcallsign 2=>tocallsign 3=>uploadfmcallsign 4=>date 5=> comments 6=>imagefilename */
        for($i=0;$i<$count;$i+=6) {
          printf("<tr><td>QSL Callsign: <b>%s</b><br>To callsign: <b>%s</b><br><br>Uploaded from %s in date %s<br><br><b>%s</b><td width=\"600px\"><img src=\"%s/%s\" alt=\"%s QSL to %s\" width=\"100%%\">\n",trim($qsl[$i]),trim($qsl[$i+1]),trim($qsl[$i+2]),trim($qsl[$i+3]),trim($qsl[$i+4]),$country,trim($qsl[$i+5]),trim($qsl[$i]),trim($qsl[$i+1]));
        }
      }
    }
  }
  closedir($fd);
}

function updatecountries ($cmd, $par1, $par2, $par3) {
  /*  update qsl.countries file:
      cmd=1 => add 1 to the qsl in the country $par1

  */
  if ($cmd==1) {
    /* add 1 to the country $par1 */
    if (!is_writable("qsl.countries")) {
      echo "<div class=\"error\">Opening qsl.contries file to update number of qsl is impossible!<br>Permission denied</div>";
      return;
    }
    $fd=fopen("qsl.countries","r+");
    if (!$fd) {
      echo "<div class=\"error\">Opening qsl.contries file to update number of qsl is impossible!<br>Permission denied</div>";
      return;
    }
    $fpos=0;
    while (!feof($fd)) {
      $line=fgets($fd,80);
      if ($line[0]!='#' && sscanf($line,"%s %s %07d\n",&$country,&$prefix,&$nqsl)==3) {
        if (!strcasecmp($country,$par1)) {
          $buffer=sprintf("%-31s %-31s %07d\n",$country,$prefix,++$nqsl);
          fseek($fd,$fpos,SEEK_SET);
          fwrite($fd,$buffer,72);
          break;
        }
      }
      $fpos=ftell($fd);
    }
    fclose($fd);
  }
  /* other commands ?? */


}

?>
